export const localEnvironmentContent = () => `NAME=dev
VERBOSE=true`

export const cliConfigTemplate = () => `{
    "controllersDirectory": "src/controllers",
    "environmentsDirectory": ""
}`

export const apiConfig = () => `import { startup, HttpStatusCode } from '@headcore/express-extensions';

export default startup({
    cwd: process.cwd(),
    env: {
        prodEnv: 'prod'
    },
    cors: { enabled: true },
    parsers: {
        json: {
            enabled: true,
            options: { limit: '2mb' }
        }
    },
    intercept: ['get', 'post', 'put', 'delete'],
    startupHandler: (app) => { 
        /**After loading environment */
        /**Before starting server*/
    },
    startedHandler: (port) => {
        /**After starting server*/
        console.log(\`Server started on port: \${port}\`);
    },
    errorHandler: (request, response, error) => {
        /** handler for intercepted http methods */
        console.error(\`Request error: \${error.message}\`);
        response.status(HttpStatusCode.INTERNAL_SERVER_ERROR).json({ });
    }
});`;


export const packageJson = (type: string, packageName: string)  => {
    if(type == 'lib') {
        return `{
            "name": "${packageName}",
            "version": "1.0.0",
            "description": "",
            "main": "index.js",
            "scripts": {
                "test": "echo \\"Error: no test specified\\" && exit 1",
                "tsc": "tsc -w"
            },
            "author": "",
            "license": "ISC"
        }`
    } else {
        return `{
            "name": "${packageName}",
            "version": "1.0.0",
            "description": "",
            "main": "index.js",
            "scripts": {
                "test": "echo \\"Error: no test specified\\" && exit 1",
                "tsc": "tsc -w",
                "nodemon": "nodemon index",
                "start": "node index"
            },
            "author": "",
            "license": "ISC"
        }`
    }
}

export const tsconfigJson = () => `{
    "compilerOptions": {
        "target": "es6",
        "module": "commonjs",
        "noImplicitAny": true,
        "removeComments": true,
        "preserveConstEnums": true,
        "sourceMap": true,
        "experimentalDecorators": true
    },
    "exclude": ["node_modules", "**/*.spec.ts"]
}
`

export const gitignore = () => `# Created by https://www.gitignore.io/api/node,visualstudiocode
# Edit at https://www.gitignore.io/?templates=node,visualstudiocode

### Node ###
# Logs
logs
*.log
npm-debug.log*
yarn-debug.log*
yarn-error.log*
lerna-debug.log*

# Diagnostic reports (https://nodejs.org/api/report.html)
report.[0-9]*.[0-9]*.[0-9]*.[0-9]*.json

# Runtime data
pids
*.pid
*.seed
*.pid.lock

# Directory for instrumented libs generated by jscoverage/JSCover
lib-cov

# Coverage directory used by tools like istanbul
coverage
*.lcov

# nyc test coverage
.nyc_output

# Grunt intermediate storage (https://gruntjs.com/creating-plugins#storing-task-files)
.grunt

# Bower dependency directory (https://bower.io/)
bower_components

# node-waf configuration
.lock-wscript

# Compiled binary addons (https://nodejs.org/api/addons.html)
build/Release

# Dependency directories
node_modules/
jspm_packages/

# TypeScript v1 declaration files
#typings/

# TypeScript cache
*.tsbuildinfo

# Optional npm cache directory
.npm

# Optional eslint cache
.eslintcache

# Optional REPL history
.node_repl_history

# Output of 'npm pack'
*.tgz

# Yarn Integrity file
.yarn-integrity

# dotenv environment variables file
.env
.env.test

# parcel-bundler cache (https://parceljs.org/)
.cache

# next.js build output
.next

# nuxt.js build output
.nuxt

# rollup.js default build output
dist/

# Uncomment the public line if your project uses Gatsby
# https://nextjs.org/blog/next-9-1#public-directory-support
# https://create-react-app.dev/docs/using-the-public-folder/#docsNav
# public

# Storybook build outputs
.out
.storybook-out

# vuepress build output
.vuepress/dist

# Serverless directories
.serverless/

# FuseBox cache
.fusebox/

# DynamoDB Local files
.dynamodb/

# Temporary folders
tmp/
temp/

### VisualStudioCode ###
.vscode/*
!.vscode/settings.json
!.vscode/tasks.json
!.vscode/launch.json
!.vscode/extensions.json

### VisualStudioCode Patch ###
# Ignore all local history of files
.history

# End of https://www.gitignore.io/api/node,visualstudiocode

# Custom
index.js
index.js.map
src/**/*.js
src/**/*.js.map`;

export const vsCodeLaunch = () => `{
    // Use IntelliSense to learn about possible attributes.
    // Hover to view descriptions of existing attributes.
    // For more information, visit: https://go.microsoft.com/fwlink/?linkid=830387
    "version": "0.2.0",
    "configurations": [
        {
            "type": "node",
            "request": "launch",
            "name": "nodemon",
            "runtimeExecutable": "nodemon",
            "program": "\${workspaceFolder}/index.js",
            "restart": true,
            "console": "integratedTerminal",
            "internalConsoleOptions": "neverOpen",
            "skipFiles": [
                "<node_internals>/**"
            ],
            "env": {
                "NODE_ENV": "dev"
            },
            "preLaunchTask": "tsc: watch - tsconfig.json"
        }
    ]
}`

export const vsCodeTasks = () => `{
	"version": "2.0.0",
	"tasks": [
		{
			"type": "typescript",
			"tsconfig": "tsconfig.json",
			"option": "watch",
			"problemMatcher": [
				"$tsc-watch"
			],
			"group": "build",
			"label": "tsc: watch - tsconfig.json"
		}
	]
}`

export const list = (value: string) => value.split(',');
